<?php namespace App\Models;

use App\Entities\Perfil\Perfil;

class PerfilModel extends ModelEntity
{
    protected $table = 'perfil';
    protected $primaryKey = 'id';
    protected $returnType = 'array';
    protected $allowedFields = [
        'descricao'
    ];
    protected $useSoftDeletes = false;
    protected $skipValidation = true;
    protected $useTimestamps = false;

    public function registerPerfil (Perfil $perfil) : void {
        $data = $perfil->toArray();
        $id_new_perfil = $this->insert($data);
        $perfil->setId($id_new_perfil);
    }

    public function updatePerfilByID (int $id_perfil, Perfil $perfil) : bool {
        $data = $perfil->toArray(true);
        if (count($data) > 0) {
            $binds = ['id_perfil' => $id_perfil];
            $sql = "UPDATE perfil ";
            $sql .= $this->generateUpdateSets($data, $binds);
            $sql .= 'WHERE perfil.id = :id_perfil:';
            $query = $this->db->query($sql, $binds);
            $errors = $this->errors();
            return !$errors;
        } else {
            return true;
        }
    }
}
